image: node:13.10.1

stages:
  - preparation
  - test
  - build
  - deploy
preparation:
  stage: preparation
  script:
    - yarn install --pure-lockfile
  artifacts:
    expire_in: 1 hour
    paths:
      - node_modules
  cache:
    paths:
      - node_modules
test:
  stage: test
  script:
    - yarn lint
    - yarn test:ci
build:
  stage: build
  script:
    - echo "Building deploy package"
    - yarn build
  artifacts:
    expire_in: 1 hour
    paths:
      - build
  only:
    - master
deploy:
  stage: deploy
  script:
    - yarn deploy:firebase --token $FIREBASE_SECRET_KEY
  environment:
    name: production
  only:
    - master
